import Engine.*;
import org.joml.Vector2d;
import org.joml.Vector3f;

import static org.lwjgl.glfw.GLFW.*;


public class DummyGame implements IGameLogic {

    public String start[];



    private final Renderer renderer;

    private int id;
    private float modulx;
    private float moduly;
    private float modulvx;
    private float modulvy;
    private float fuel;
    private float L;
    private float R;
    private int doprava=0;
    private int doleva=0;
    private int nahoru=0;
    private long time;
    private boolean hraje;
    private boolean auto;
    private int maxv=1000000;

    private GameItem[] gameItems;


    public DummyGame(String start[]) {
        renderer = new Renderer();
        this.auto=false;
        this.time=System.currentTimeMillis();
        this.hraje=true;
        this.start=start;
        this.id=Integer.parseInt(start[0]);
        this.modulx=Float.parseFloat(start[1].split(" ")[0]);
        this.moduly=Float.parseFloat(start[1].split(" ")[1]);
        this.modulvx=Float.parseFloat(start[2].split(" ")[0]);
        this.modulvy=Float.parseFloat(start[2].split(" ")[1]);
        this.fuel=Float.parseFloat(start[3]);
        this.L=Float.parseFloat(start[4].split(" ")[0]);
        this.R=Float.parseFloat(start[4].split(" ")[1]);


    }

    @Override
    public void init(Window window) throws Exception {
        renderer.init(window);
        float[] positions = new float[]{
            -0.5f, 0.5f, 0.5f,
            -0.5f, -0.5f, 0.5f,
            0.5f, -0.5f, 0.5f,
            0.5f, 0.5f, 0.5f,
            -0.5f, 0.5f, -0.5f,
            0.5f, 0.5f, -0.5f,
            -0.5f, -0.5f, -0.5f,
            0.5f, -0.5f, -0.5f,
            -0.5f, 0.5f, -0.5f,
            0.5f, 0.5f, -0.5f,
            -0.5f, 0.5f, 0.5f,
            0.5f, 0.5f, 0.5f,
            0.5f, 0.5f, 0.5f,
            0.5f, -0.5f, 0.5f,
            -0.5f, 0.5f, 0.5f,
            -0.5f, -0.5f, 0.5f,
            -0.5f, -0.5f, -0.5f,
            0.5f, -0.5f, -0.5f,
            -0.5f, -0.5f, 0.5f,
            0.5f, -0.5f, 0.5f,};
        float[] textCoords = new float[]{
            0.0f, 0.0f,
            0.0f, 0.5f,
            0.5f, 0.5f,
            0.5f, 0.0f,
            0.0f, 0.0f,
            0.5f, 0.0f,
            0.0f, 0.5f,
            0.5f, 0.5f,
            0.0f, 0.5f,
            0.5f, 0.5f,
            0.0f, 1.0f,
            0.5f, 1.0f,
            0.0f, 0.0f,
            0.0f, 0.5f,
            0.5f, 0.0f,
            0.5f, 0.5f,
            0.5f, 0.0f,
            1.0f, 0.0f,
            0.5f, 0.5f,
            1.0f, 0.5f,};
        int[] indices = new int[]{
            0, 1, 3, 3, 1, 2,
            8, 10, 11, 9, 8, 11,
            12, 13, 7, 5, 12, 7,
            14, 15, 6, 4, 14, 6,
            16, 18, 19, 17, 16, 19,
            4, 6, 7, 5, 4, 7,};
        Texture texture = new Texture("/resources/textures/sputnik.png");
        Mesh mesh = new Mesh(positions, textCoords, indices, texture);
        GameItem rocket = new GameItem(mesh);
        rocket.setScale(0.5f);
        rocket.setPosition(modulx/20, moduly/20, -2);
        Texture texture2 = new Texture("/resources/textures/grassblock.png");
        Mesh mesh2 = new Mesh(positions, textCoords, indices, texture2);
        GameItem landing = new GameItem(mesh2);
        landing.setScale((R-L)/20);
        landing.setPosition((L+(R-L)/2)/20, -(R-L)/2/20, -2);
        GameItem end = new GameItem(mesh2);
        end.setScale(0.5f);
        end.setPosition(0, 10, -2);
        gameItems = new GameItem[]{rocket, landing};
    }

    @Override
    public void input(Window window, MouseInput mouseInput) {
        if (hraje) {
            if (window.isKeyPressed(GLFW_KEY_W) && this.fuel > 0) {
                if (this.nahoru == 0) {
                    this.nahoru = 1;
                    connect();
                }
            } else {
                if (this.nahoru == 1 && !auto) {
                    this.nahoru = 0;
                    connect();
                }
            }
            if (window.isKeyPressed(GLFW_KEY_D) && this.fuel > 0) {
                if (this.doprava == 0) {
                    this.doprava = 1;
                    connect();
                }
            } else {
                if (this.doprava == 1) {
                    this.doprava = 0;
                    connect();
                }
            }
            if (window.isKeyPressed(GLFW_KEY_A) && this.fuel > 0) {
                if (this.doleva == 0) {
                    this.doleva = 1;
                    connect();
                }
            } else {
                if (this.doleva == 1) {
                    this.doleva = 0;
                    connect();
                }
            }
            if (mouseInput.isLeftButtonPressed()) {
                Vector2d rotVec = mouseInput.currentPos;
            }

            if (this.fuel == 0) {
                if (this.nahoru == 1 || this.doprava == 1 || this.doleva == 1) {
                    this.nahoru = 0;
                    this.doleva = 0;
                    this.doprava = 0;
                    connect();
                }
            }

            if (window.isKeyPressed(GLFW_KEY_I)) {
                auto=true;
                System.out.println("Nefunguje, smůla!");
            }

            double dt = (System.currentTimeMillis() - time) / 1000.0;
            this.modulx = (float) (this.modulx + this.modulvx * dt + 1 / 2 * (6 * this.doprava - 6 * this.doleva) * dt * dt);
            this.moduly = (float) (this.moduly + this.modulvy * dt + 1 / 2 * (-7 + 12 * this.nahoru) * dt * dt);
            this.modulvx = (float) (this.modulvx + (6 * this.doprava - 6 * this.doleva) * dt);
            this.modulvy = (float) (this.modulvy + (-7 + 12 * this.nahoru) * dt);
            this.fuel = (float) (this.fuel - 1 / 2 * (this.doprava + this.doleva + this.nahoru * 2) * dt);
            time = System.currentTimeMillis();

            if (this.moduly < 10) {
                this.hraje = false;
                this.modulvx = 0;
                this.modulvy = 0;
                this.moduly = 10;
                String c=connect();
                System.out.println(c);
                System.out.println("Press space to new game");
            }

            if (auto){
                if ((0 < this.modulvy - (5) * (modulvy/5-Math.sqrt(Math.pow(this.modulvy,2)-10*(this.moduly-10))/5)
                        || this.maxv<1+this.modulvy) && this.nahoru==0){
                    this.nahoru=1;
                    System.out.println(moduly);
                    connect();
                }

            }

            gameItems[0].setPosition(modulx / 20, moduly / 20, -2);
            Vector3f camera = Renderer.transformation.getCameraPos();
            camera.x = (L + (R - L) / 2) / 20;
            if (110 < moduly) {
                camera.y = moduly / 40;
                camera.z = moduly / 20;
            }

            Renderer.transformation.setCameraPos(camera);
        }

        if (window.isKeyPressed(GLFW_KEY_SPACE) && !hraje) {
            Main.main(new String[0]);
            try{Thread.sleep(1000000);}catch (Exception e){System.out.println(e);}
        }
    }


    @Override
    public void render(Window window) {
        renderer.render(window, gameItems);
    }

    @Override
    public void cleanup() {
        renderer.cleanup();
        for (GameItem gameItem : gameItems) {
            gameItem.getMesh().cleanUp();
        }
    }

    public String connect(){
        String r="";
        try {
            r = Main.getHTML(Main.url+"/stav?id="+this.id+"&nahoru="+this.nahoru+"&doleva="+this.doleva+"&doprava="+this.doprava);
        } catch(Exception e){
            System.out.println("Tak to je špatné, nejde načíst start:");
            System.out.println(e);
        }
        return r;
    }

}
