package Engine;

import org.joml.Vector2d;

import static org.lwjgl.glfw.GLFW.*;

public class MouseInput {

    public final Vector2d currentPos;

    private boolean leftButtonPressed = false;

    MouseInput() {
        currentPos = new Vector2d(0, 0);
    }

    void init(Window window) {
        glfwSetCursorPosCallback(window.getWindowHandle(), (windowHandle, xpos, ypos) -> {
            currentPos.x = xpos;
            currentPos.y = ypos;
        });
        glfwSetMouseButtonCallback(window.getWindowHandle(), (windowHandle, button, action, mode) ->
                leftButtonPressed = button == GLFW_MOUSE_BUTTON_1 && action == GLFW_PRESS);
    }

    public boolean isLeftButtonPressed() {
        return leftButtonPressed;
    }
}
